<?php

abstract class BaseFile extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable('file');
    $this->SetColumn('id', array('type' => 'int(11)', 'primary' => true, 'autoincrement' => true, 'default' => 0, ));
    $this->SetColumn('user_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('file_type_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('name', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('file', array('type' => 'string(255)', 'default' => 0, ));
    $this->SetColumn('date_create', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));
    $this->SetColumn('date_update', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));

    $this->SetupRelation('User', array('type' => 'oneToOne', 'class' => 'User', 'foreign' => 'id', 'local' => 'user_id', ));
    $this->SetupRelation('Type', array('type' => 'oneToOne', 'class' => 'FileType', 'foreign' => 'id', 'local' => 'file_type_id', ));
    $this->SetupRelation('Specs', array('type' => 'oneToMany', 'class' => 'FileSpecs', 'foreign' => 'file_id', 'local' => 'id', ));
  }
}

?>