<?php

abstract class BaseRessource extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable('ressource');
    $this->SetColumn('id', array('type' => 'int(11)', 'primary' => true, 'autoincrement' => true, 'default' => 0, ));
    $this->SetColumn('ressource_type_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('user_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('categorie_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('name', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('description', array('type' => 'text', 'default' => '', ));
    $this->SetColumn('date_create', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));
    $this->SetColumn('date_update', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));

    $this->SetupRelation('Type', array('type' => 'oneToOne', 'class' => 'RessourceType', 'foreign' => 'id', 'local' => 'ressource_type_id', ));
    $this->SetupRelation('User', array('type' => 'oneToOne', 'class' => 'User', 'foreign' => 'id', 'local' => 'user_id', ));
    $this->SetupRelation('Categorie', array('type' => 'oneToOne', 'class' => 'Categorie', 'foreign' => 'id', 'local' => 'categorie_id', ));
    $this->SetupRelation('Versions', array('type' => 'oneToMany', 'class' => 'RessourceVersion', 'foreign' => 'ressource_id', 'local' => 'id', 'cascadeDelete' => true, ));
    $this->SetupRelation('RessourceSets', array('type' => 'manyToMany', 'class' => 'RessourceSet', 'refClass' => 'RessourceSetContent', 'foreign' => 'ressource_set_id', 'local' => 'ressource_id', 'cascadeDelete' => true, ));
  }
}

?>