<?php

abstract class BaseRessourceSet extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable('ressource_set');
    $this->SetColumn('id', array('type' => 'int(11)', 'primary' => true, 'autoincrement' => true, 'default' => 0, ));
    $this->SetColumn('user_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('name', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('description', array('type' => 'text', 'default' => '', ));
    $this->SetColumn('date_create', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));
    $this->SetColumn('date_update', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));

    $this->SetupRelation('User', array('type' => 'oneToOne', 'class' => 'User', 'foreign' => 'id', 'local' => 'user_id', ));
    $this->SetupRelation('Ressources', array('type' => 'manyToMany', 'class' => 'Ressource', 'refClass' => 'RessourceSetContent', 'foreign' => 'ressource_id', 'local' => 'ressource_set_id', 'cascadeDelete' => true, ));
  }
}

?>