<?php

abstract class BaseRessourceVersion extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable('ressource_version');
    $this->SetColumn('id', array('type' => 'int(11)', 'primary' => true, 'autoincrement' => true, 'default' => 0, ));
    $this->SetColumn('ressource_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('user_id', array('type' => 'int(11)', 'default' => 0, ));
    $this->SetColumn('name', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('description', array('type' => 'text', 'default' => NULL, ));
    $this->SetColumn('date_create', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));
    $this->SetColumn('date_update', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));

    $this->SetupRelation('Ressource', array('type' => 'oneToOne', 'class' => 'Ressource', 'foreign' => 'id', 'local' => 'ressource_id', ));
    $this->SetupRelation('User', array('type' => 'oneToOne', 'class' => 'User', 'foreign' => 'id', 'local' => 'user_id', ));
    $this->SetupRelation('File', array('type' => 'manyToMany', 'class' => 'File', 'refClass' => 'RessourceFile', 'foreign' => 'file_id', 'local' => 'ressource_version_id', ));
  }
}

?>