<?php

abstract class BaseUser extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable('user');
    $this->SetColumn('id', array('type' => 'int(11)', 'primary' => true, 'autoincrement' => true, 'default' => 0, ));
    $this->SetColumn('pseudo', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('email', array('type' => 'string(255)', 'default' => '', ));
    $this->SetColumn('mdp', array('type' => 'string(32)', 'default' => '', ));
    $this->SetColumn('date_create', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));
    $this->SetColumn('date_update', array('type' => 'datetime', 'default' => '0000-00-0000:00:00', ));

    $this->SetupRelation('RessourceSets', array('type' => 'oneToMany', 'class' => 'RessourceSet', 'foreign' => 'user_id', 'local' => 'id', ));
    $this->SetupRelation('Ressources', array('type' => 'oneToMany', 'class' => 'Ressource', 'foreign' => 'user_id', 'local' => 'id', ));
    $this->SetupRelation('RessourceVersions', array('type' => 'oneToMany', 'class' => 'RessourceVersion', 'foreign' => 'user_id', 'local' => 'id', ));
    $this->SetupRelation('Files', array('type' => 'oneToMany', 'class' => 'File', 'foreign' => 'user_id', 'local' => 'id', ));
  }
}

?>