<?php
require_once(dirname(__FILE__).'/sfYaml/sfYamlParser.php');

class MySQLObjectGenerator
{
  private $modelPath;

  public function __construct()
  {
    if(!class_exists('sfYamlParser'))
      exit('Le parser n\'est pas charg');
  }

  public function Generate($files)
  {
    if(is_array($files))
    {
      foreach($files as $file)
        $this->Generate($file);
      return;
    }

    $data = $this->GetDataFromYml($files);

    foreach($data as $class=>$property)
    {
      $content = '<?php

abstract class Base'.$class.' extends MySQLObject
{
  public function Configure()
  {
    $this->SetTable(\''.$property['tableName'].'\');';

      foreach($property['columns'] as $column=>$params)
      {
        $content .= '
    $this->SetColumn(\''.$column.'\', '.$this->CleanVarExport(var_export($params, TRUE)).');';
      }

      if(isset($property['relations']))
      {
        $content .= "\n";
        foreach($property['relations'] as $relation=>$params)
        {
          $content .= '
    $this->SetupRelation(\''.$relation.'\', '.$this->CleanVarExport(var_export($params, TRUE)).');';
        }
      }

      $content .= '
  }
}

?>';

      $f = fopen('./models/generated/Base'.$class.'.php', 'w+');
      fputs($f, $content);
      fclose($f);

      if(!file_exists('./models/'.$class.'.php'))
      {
        $content = '<?php

class '.$class.' extends Base'.$class.'
{
}

?>';
        $f = fopen('./models/'.$class.'.php', 'w+');
        fputs($f, $content);
        fclose($f);
      }
    }
  }


  private function GetDataFromYml($file)
  {
    if(!file_exists($file))
      exit('Le fichier "'.$file.'" n\'existe pas');

    $yaml = new sfYamlParser();

    try
    {
      return $yaml->parse(file_get_contents($file));
    }
    catch (InvalidArgumentException $e) // an error occurred during parsing
    {
      echo "Unable to parse the YAML string: ".$e->getMessage();
      exit();
    }
  }

  private function CleanVarExport($str)
  {
    $str = preg_replace(array("(\s*)", "(\t*)", "(\n*)", "(\r*)"), "", $str);
    $str = str_replace(array(",", "=>"), array(', ', ' => '), $str);

    return $str;
  }
}

?>
